package ec3.client.applet;

import java.awt.Button;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Label;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

/**
 * ein Fenster zum erstellen von Chatrumen
 *
 * @since 0.4
 */
public class ChatRoomCreate extends Frame
implements WindowListener, ActionListener, KeyListener {
	
	/**
	 * erstellt ein neues Eingabefenster
	 *
	 * @param parent Rckrufobjekt
	 * @param enableCreatePwd <code>true</code>, wenn das Erstellen von Rumen mit Passwort
	 *        mglich ist.
	 */
	public ChatRoomCreate (ChatRoomList parent, boolean enableCreatePwd) {
		super ("Chatraum erstellen");
		
		this.parent = parent;
		
		addWindowListener(this);
		addKeyListener(this);
		
		layout = new GridBagLayout ();
		setLayout (layout);
		setSize (250, 200);
		
		GridBagConstraints c = new GridBagConstraints ();
		
		c.anchor = GridBagConstraints.NORTHEAST;
		c.fill = GridBagConstraints.NONE;
		c.gridheight = 1;
		c.gridwidth = 1;
		c.gridx = 0;
		c.gridy = 0;
		c.weightx = 0;
		c.weighty = 0;
		nameLabel = new Label ("Name");
		layout.setConstraints (nameLabel, c);
		add (nameLabel);
		
		c.fill = GridBagConstraints.BOTH;
		c.gridwidth = 3;
		c.gridx = 1;
		c.weightx = 1;
		nameTextField = new TextField ();
		nameTextField.addActionListener(this);
		nameTextField.addKeyListener(this);
		layout.setConstraints (nameTextField, c);
		add (nameTextField);
		
		c.fill = GridBagConstraints.NONE;
		c.gridwidth = 1;
		c.gridx = 0;
		c.gridy = 1;
		c.weightx = 0;
		c.weighty = 1;
		descLabel = new Label ("Beschreibung");
		layout.setConstraints (descLabel, c);
		add (descLabel);
		
		c.fill = GridBagConstraints.BOTH;
		c.gridwidth = 3;
		c.gridx = 1;
		c.weightx = 1;
		descTextArea = new TextArea ();
		descTextArea.addKeyListener(this);
		layout.setConstraints (descTextArea, c);
		add (descTextArea);
		
		c.fill = GridBagConstraints.NONE;
		c.gridheight = 1;
		c.gridwidth = 1;
		c.gridx = 0;
		c.gridy = 2;
		c.weightx = 0;
		c.weighty = 0;
		pwdLabel = new Label ("Passwort");
		pwdLabel.setEnabled (enableCreatePwd);
		layout.setConstraints (pwdLabel, c);
		add (pwdLabel);
		
		c.fill = GridBagConstraints.BOTH;
		c.gridwidth = 3;
		c.gridx = 1;
		c.weightx = 1;
		pwdTextField = new TextField ();
		if (enableCreatePwd) {
			pwdTextField.setEchoChar('x');
		} else {
			pwdTextField.setText ("TODO"); //Passwort eingeben verbieten
			pwdTextField.setEnabled (false);
		}
		layout.setConstraints (pwdTextField, c);
		add (pwdTextField);
		
		c.gridwidth = 2;
		c.gridx = 0;
		c.gridy = 3;
		createButton = new Button ("Erstellen");
		createButton.addActionListener(this);
		createButton.addKeyListener(this);
		layout.setConstraints (createButton, c);
		add (createButton);
		
		c.gridx = 2;
		cancelButton = new Button ("Abbrechen");
		cancelButton.addActionListener(this);
		cancelButton.addKeyListener(this);
		layout.setConstraints (cancelButton, c);
		add (cancelButton);
		
	}//ChatRoomCreate(...)
	
	/**
	 * das Layout des Fensters
	 */
	private GridBagLayout layout;
	
	/**
	 * das Textfeld fr den Chatraumnamen
	 */
	private TextField nameTextField;
	
	/**
	 * das Textfeld fr das Passwort
	 */
	private TextField pwdTextField;
	
	/**
	 * die TextArea fr die Beschreibung
	 */
	private TextArea descTextArea;
	
	/**
	 * das Label fr den Chatnamen
	 */
	private Label nameLabel;
	
	/**
	 * das Laben fr die Beschreibung
	 */
	private Label descLabel;
	
	/**
	 * das Label fr das PAsswort
	 */
	private Label pwdLabel;
	
	/**
	 * der "Erstellen"-Button
	 */
	private Button createButton;
	
	/**
	 * der "Abbrechen"-Button
	 */
	private Button cancelButton;
	
	/**
	 * die Chatraumliste, die dieses Fenster geffnet hat
	 */
	private ChatRoomList parent;

	/* 
	 * (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowActivated(java.awt.event.WindowEvent)
	 */
	public void windowActivated(WindowEvent e) {
		// nix
	}

	/* 
	 * (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowClosed(java.awt.event.WindowEvent)
	 */
	public void windowClosed(WindowEvent e) {
		// nix
	}

	/* 
	 * (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowClosing(java.awt.event.WindowEvent)
	 */
	public void windowClosing(WindowEvent e) {
		if (e.getSource() != this) return;
		setVisible(false);
		nameTextField.setText ("");
		descTextArea.setText ("");
		pwdTextField.setText("");
	}

	/* 
	 * (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowDeactivated(java.awt.event.WindowEvent)
	 */
	public void windowDeactivated(WindowEvent e) {
		// nix
	}

	/* 
	 * (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowDeiconified(java.awt.event.WindowEvent)
	 */
	public void windowDeiconified(WindowEvent e) {
		// nix
	}

	/* 
	 * (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowIconified(java.awt.event.WindowEvent)
	 */
	public void windowIconified(WindowEvent e) {
		// nix
	}

	/* 
	 * (non-Javadoc)
	 * @see java.awt.event.WindowListener#windowOpened(java.awt.event.WindowEvent)
	 */
	public void windowOpened(WindowEvent e) {
		// nix
	}

	/* 
	 * (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		if ((e.getSource() == createButton)
		 || (e.getSource() == nameTextField)
		 || (e.getSource() == pwdTextField)
		) {
			if (nameTextField.getText ().trim ().length () > 0) {
				setVisible(false);
				parent.createCallBack (nameTextField.getText (),
				 descTextArea.getText (), pwdTextField.getText());
				nameTextField.setText ("");
				descTextArea.setText ("");
				pwdTextField.setText("");
			}
		} else if (e.getSource() == cancelButton) {
			nameTextField.setText ("");
			descTextArea.setText ("");
			pwdTextField.setText("");
			setVisible(false);
		}//if
	}

	/* 
	 * (non-Javadoc)
	 * @see java.awt.event.KeyListener#keyPressed(java.awt.event.KeyEvent)
	 */
	public void keyPressed(KeyEvent e) {
		//Escape -> Fenster vestecken
		if (/*(e.getSource() == this) && */(e.getModifiers() == 0)
		 && (e.getKeyCode() == KeyEvent.VK_ESCAPE)) {
			nameTextField.setText ("");
			descTextArea.setText ("");
			pwdTextField.setText("");
			setVisible(false);
			e.consume();
		//Tab und Shift+Tab im Beschreibungsfeld -> Focus bewegen
		} else if ((e.getSource() == descTextArea)
		 && (e.getKeyCode() == KeyEvent.VK_TAB)) {
			if (e.getModifiers() == InputEvent.SHIFT_MASK) {
				nameTextField.requestFocus ();
			} else if (e.getModifiers() == 0) {
				descTextArea.transferFocus ();
			}//if
			e.consume();
		// Enter auf createButton
		} else if ((e.getSource() == createButton)
		 && (e.getKeyCode() == KeyEvent.VK_ENTER) && (e.getModifiers() == 0)) {
			if (nameTextField.getText ().trim ().length () > 0) {
				setVisible(false);
				parent.createCallBack (nameTextField.getText (),
				 descTextArea.getText (), pwdTextField.getText());
				nameTextField.setText ("");
				descTextArea.setText ("");
				pwdTextField.setText("");
			}
			e.consume();
		// Enter auf cancelButton
		} else if ((e.getSource() == cancelButton)
		 && (e.getKeyCode() == KeyEvent.VK_ENTER) && (e.getModifiers() == 0)) {
			nameTextField.setText ("");
			descTextArea.setText ("");
			pwdTextField.setText("");
			setVisible(false);
			e.consume();
		}
	}

	/* 
	 * (non-Javadoc)
	 * @see java.awt.event.KeyListener#keyReleased(java.awt.event.KeyEvent)
	 */
	public void keyReleased(KeyEvent e) {
		// nix
	}

	/* 
	 * (non-Javadoc)
	 * @see java.awt.event.KeyListener#keyTyped(java.awt.event.KeyEvent)
	 */
	public void keyTyped(KeyEvent e) {
		// nix
	}
}