package ec3.client.applet;

import java.awt.*;

/**
 * ein LayoutManager, der die Komponenten einfach mittels ihrer preferredSize
 * untereinander anordnet
 *
 * @since 0.4
 */
public class MyBoxLayout implements LayoutManager2 {
	
	/* 
	 * (non-Javadoc)
	 * @see java.awt.LayoutManager#addLayoutComponent(java.lang.String, java.awt.Component)
	 */
	public void addLayoutComponent(String name, Component comp) {
		// nix
	}
	
	/* 
	 * (non-Javadoc)
	 * @see java.awt.LayoutManager2#addLayoutComponent(java.awt.Component, java.lang.Object)
	 */
	public void addLayoutComponent(Component comp, Object constraints) {
		// nix
	}
	
	/* 
	 * (non-Javadoc)
	 * @see java.awt.LayoutManager2#getLayoutAlignmentX(java.awt.Container)
	 */
	public float getLayoutAlignmentX(Container parent) {
		return 0;
	}
	
	/* 
	 * (non-Javadoc)
	 * @see java.awt.LayoutManager2#getLayoutAlignmentY(java.awt.Container)
	 */
	public float getLayoutAlignmentY(Container parent) {
		return 0;
	}
	
	/* 
	 * (non-Javadoc)
	 * @see java.awt.LayoutManager2#invalidateLayout(java.awt.Container)
	 */
	public void invalidateLayout(Container parent) {
		// nix
	}
	
	/* 
	 * (non-Javadoc)
	 * @see java.awt.LayoutManager#layoutContainer(java.awt.Container)
	 */
	public void layoutContainer(Container parent) {
		int count = parent.getComponentCount ();
		Insets insets = parent.getInsets ();
		int top = insets.top;
		for (int i = 0; i < count; i++) {
			Component c = parent.getComponent (i);
			Dimension d = c.getPreferredSize ();
//			System.out.println("top: " + top);
			c.setBounds (insets.left, top, d.width, d.height);
			top += d.height;
		}
//		for (int i = 0; i < count; i++) {
//			Component c = parent.getComponent (i);
//			System.out.println(c.getBounds());
//		}
	}
	
	/* 
	 * (non-Javadoc)
	 * @see java.awt.LayoutManager2#maximumLayoutSize(java.awt.Container)
	 */
	public Dimension maximumLayoutSize(Container parent) {
		return preferredLayoutSize (parent);
	}
	
	/* 
	 * (non-Javadoc)
	 * @see java.awt.LayoutManager#minimumLayoutSize(java.awt.Container)
	 */
	public Dimension minimumLayoutSize(Container parent) {
		return preferredLayoutSize (parent);
	}
	
	/*
	 * (non-Javadoc)
	 * @see java.awt.LayoutManager#preferredLayoutSize(java.awt.Container)
	 */
	public Dimension preferredLayoutSize(Container parent) {
		
		int count = parent.getComponentCount ();
		Insets insets = parent.getInsets ();
		int top = insets.top;
		int maxwidth = 0;
		for (int i = 0; i < count; i++) {
			Component c = parent.getComponent (i);
			Dimension d = c.getPreferredSize ();
			top += d.height;
			if (d.width > maxwidth) maxwidth = d.width;
		}
		return new Dimension (maxwidth + insets.left, top);
	}
	
	/* 
	 * (non-Javadoc)
	 * @see java.awt.LayoutManager#removeLayoutComponent(java.awt.Component)
	 */
	public void removeLayoutComponent(Component comp) {
		// nix
	}
	
}