/*
 * Erstellt: 01.06.2005
 * Gendert: $Date$
 * 
 * $Log$
 */
package ec3.client.applet.launcher;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * Ein einfaches Applet zum Editieren einer lokalen Datei. Gedacht zum starten
 * aus {@link Launcher}. Der Dateiname wird als Parameter "edit" bergeben.
 * 
 * @author am
 * @version $Id$
 */
public class EditorApplet
extends Applet implements ActionListener {
	
	/**
	 * Der Name der zu editierenden Datei.
	 */
	private String file;
	
	/**
	 * Die TextArea zum ndern des Dateiinhaltes.
	 */
	private TextArea editTextArea;
	
	/**
	 * Der Button "speichern".
	 */
	private Button saveButton;
	
	/**
	 * Der Button "abbrechen".
	 */
	private Button cancelButton;
	
	/**
	 * Das Panel fr die 2 Buttons.
	 */
	private Panel panel;
	
	/* (non-Javadoc)
	 * @see java.applet.Applet#init()
	 */
	public void init() {
		file = getParameter("edit");
		editTextArea = new TextArea();
		panel = new Panel();
		saveButton = new Button("speichern");
		cancelButton = new Button("abbrechen");
		
		saveButton.addActionListener(this);
		cancelButton.addActionListener(this);
		
		setLayout(new BorderLayout());
		add(editTextArea, BorderLayout.CENTER);
		add(panel, BorderLayout.SOUTH);
		panel.setLayout(new GridLayout(1, 2));
		panel.add(saveButton);
		panel.add(cancelButton);
		
		try {
			BufferedReader r = new BufferedReader(new FileReader(file));
			while (r.ready()) {
				String line = r.readLine();
				editTextArea.append(line + "\n");
			}
			r.close();
			System.out.println(file + " geladen");
		} catch (FileNotFoundException e) {
			System.out.println(file + " existiert nicht -> wird beim speichern angelegt.");
			// ignoriert -> Datei neu anlegen
		} catch (IOException e) {
			add(new Label("Fehler beim Lesen von " + file), BorderLayout.NORTH);
			e.printStackTrace();
			return;
		}
	}
	
	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == saveButton) {
			try {
				PrintWriter w = new PrintWriter(new FileWriter(file));
				w.print(editTextArea.getText());
				w.close();
				System.out.println(file + " gespeichert");
			} catch (IOException e1) {
				add(new Label("Fehler beim Lesen von " + file), BorderLayout.NORTH);
				e1.printStackTrace();
				return;
			}
		}
		try {
			getAppletContext().showDocument(new URL(getCodeBase(), "close.html"));
		} catch (MalformedURLException e1) {
			// passiert net!?
		}
	}
}

