package ec3.shared;

/**
 * Listeneintrag fr die Chatraumliste
 */
public final class ChatRoomListItem {

        /**
         * Standard-Konstruktor
         */
        public ChatRoomListItem () {
                super ();

                this.name = "";
                this.users = 0;
                this.pwd = false;
                this.desc = "";
                this.bold = false;

        }

        /**
         * Konstruktor
         * 
         * @param name der Name des Chatraumes
         * @param users die Useranzahl im Chatraum
         * @param desc die Beschreibung des Chatraumes
         */
        public ChatRoomListItem (String name, int users, String desc) {
                super ();

                this.name = name;
                this.users = users;
                this.pwd = false;
                this.desc = desc;
                this.bold = false;

        }

        /**
         * Konstruktor
         * 
         * @param name der Name des Chatraumes
         * @param users die Useranzahl im Chatraum
         * @param pwd true, wenn der Chatraum ein Passwort hat
         * @param desc die Beschreibung des Chatraumes
         */
        public ChatRoomListItem (String name, int users, boolean pwd, String desc) {
                super ();
                this.name = name;
                this.users = users;
                this.pwd = pwd;
                this.desc = desc;
                this.bold = false;

        }

        /**
         * Konstruktor
         * 
         * @param name der Name des Chatraumes
         * @param users die Useranzahl im Chatraum
         * @param pwd true, wenn der Chatraum ein Passwort hat
         * @param desc die Beschreibung des Chatraumes
         * @param bold Anzeige fett? (nur Server)
         */
        public ChatRoomListItem (String name, int users, boolean pwd, String desc, boolean bold) {
                super ();

                this.name = name;
                this.users = users;
                this.pwd = pwd;
                this.desc = desc;
                this.bold = bold;

        }

        // public-Membervariablen zum einfacheren Abfragen
        /**
         * Name des Chatraumes
         */
        public String name;
        
        /**
         * Anzahl User
         */
        public int users;
        
        /**
         * Passwort?
         */
        public boolean pwd;
        
        /**
         * Beschreibung
         */
        public String desc;
        
        /**
         * Anzeige fett? (nur Server)
         */
        public boolean bold;

}