package ec3.shared;

import java.util.EventObject;

/**
 * Eventobjekt fr diverse Callback-Ereignisse
 */
public class EC3Event extends EventObject {
	
	/**
	 * erzeugt ein neues EC3Event
	 * 
	 * @param source die Quelle des Ereignisses
	 * @param event das Ereignis
	 * @param data die Daten zum Ereignis
	 */
	public EC3Event (Object source, String event, String[] data) {
		super (source);
		
		this.event = event;
		
		if (data == null) {
			
			this.data = Tools.emptyStringArray;
			
		} else {
			
			this.data = data;
			
		}
		
	}//EC3Event ()
	
	/**
	 * gibt den Grund des Events zurck
	 * 
	 * @return der Grund
	 */
	public String getEvent () {
		
		return event;
		
	}//getEvent ()
	
	/**
	 * gibt zustzlicht Informationen zum Event zurck
	 * 
	 * @return die Daten
	 */
	public String[] getData () {
		
		return data;
		
	}//getData
	
	/**
	 * das Ereignis
	 */
	private String event;
	
	/**
	 * die Daten
	 */
	private String[] data;
	
}//EC3Event