package ec3.shared;

import java.util.Vector;

/**
 * Klasse zum Versenden der Callback-Ereignisse
 */
public class EC3EventDealer {
	
	/**
	 * erstellt einen neuen EC3EventDealer
	 */
	public EC3EventDealer () {
		list = new Vector ();
	}//EC3EventDealer ()
	
	/**
	 * fgt einen neuen Listener ein
	 * 
	 * @param listener der hunzuzufgende Listener
	 */
	public void addEC3Listener (EC3Listener listener) {
		if ((listener != null) && (list.indexOf (listener) == -1)) {
			list.addElement (listener);
		}
	}//addEC3Listener (...)
	
	/**
	 * entfernt einen Listener
	 * 
	 * @param listener der zu entfernende Listener
	 */
	public void removeEC3Listener (EC3Listener listener) {
		list.removeElement (listener);
	}//removeEC3Listener (...)
	
	/**
	 * Methode zum Absenden eines Events
	 * 
	 * @param source die Quelle des Ereignisses
	 * @param event das zu sendende Ereignis
	 * @param data die Daten zum Ereignis
	 */
	public void fireEC3Event (Object source, String event, String[] data) {
		EC3Listener[] listeners = new EC3Listener[list.size ()];
		list.copyInto (listeners);
		EC3Event e = new EC3Event (source, event, data);
		for (int i = listeners.length - 1; i >= 0; i -= 1) {
			listeners[i].EC3CallBack(e);
		}//for
		
	}//fireEC3Event (...)
	
	/**
	 * die Liste aller registrierten Listener
	 */
	private Vector list;
	
}//EC3EventDealer