package ec3.shared;

/**
 * ein Paket des EC3-Protokolls
 * 
 * hat Public-Felder, um die Benutzung zu vereinfachen
 * 
 * @author AM
 */
class EC3Packet {
	
	/**
	 * erstellt ein neues EC3Packet
	 */
	public EC3Packet () {
		
		command = null;
		dataLength = -1;
		headerEndMark = false;
		data = null;
		dataDone = 0;
		
	}
	
	/**
	 * der gesendete Befehl
	 */
	public String command;
	
	/**
	 * die Lnge der Daten
	 */
	public int dataLength;
	
	/**
	 * die Lnge der bereits erhaltenen Daten
	 */
	public int dataDone;
	
	/**
	 * true, wenn das Header-Ende-Zeichen empfangen wurde 
	 */
	public boolean headerEndMark;
	
	/**
	 * die Daten zum Befehl
	 */
	public byte[] data;
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		StringBuffer s = new StringBuffer("EC3Packet\ncommand: ");
		if (command != null) {
			s.append("\"").append(command).append("\"");
		} else {
			s.append("null");
		}
		s.append("\ndataLength: ");
		if (dataLength > -1) {
			s.append(dataLength);
		} else {
			s.append("-");
		}
		s.append("\nheaderEndMark: ");
		if (headerEndMark) {
			s.append("true");
		} else {
			s.append("false");
		}
		s.append("\ndata: ");
		if (data != null) {
			s.append(Tools.escape(new String(data)));
		} else {
			s.append("null");
		}
		return s.toString();
	}
}